Index: liveMedia/RTSPServer.cpp
===================================================================
--- liveMedia/RTSPServer.cpp	(revision 14473)
+++ liveMedia/RTSPServer.cpp	(revision 14474)
@@ -420,7 +420,8 @@
 }
 
 void RTSPServer::RTSPClientConnection
-::handleCmd_DESCRIBE(char const* urlPreSuffix, char const* urlSuffix, char const* fullRequestStr) {
+::handleCmd_DESCRIBE(char const* urlPreSuffix, char const* urlSuffix, 
+                     char const* urlParams, char const* fullRequestStr) {
   ServerMediaSession* session = NULL;
   char* sdpDescription = NULL;
   char* rtspURL = NULL;
@@ -440,7 +441,7 @@
     // for "application/sdp", because that's what we're sending back #####
     
     // Begin by looking up the "ServerMediaSession" object for the specified "urlTotalSuffix":
-    session = fOurServer.lookupServerMediaSession(urlTotalSuffix);
+    session = fOurServer.lookupServerMediaSession(urlTotalSuffix, urlParams);
     if (session == NULL) {
       handleCmd_notFound();
       break;
@@ -689,7 +690,7 @@
   return True;
 }
 
-void RTSPServer::RTSPClientConnection::handleHTTPCmd_StreamingGET(char const* /*urlSuffix*/, char const* /*fullRequestStr*/) {
+void RTSPServer::RTSPClientConnection::handleHTTPCmd_StreamingGET(char const* /*urlSuffix*/, char const* urlParams, char const* /*fullRequestStr*/) {
   // By default, we don't support requests to access streams via HTTP:
   handleHTTPCmd_notSupported();
 }
@@ -869,6 +870,7 @@
     char cmdName[RTSP_PARAM_STRING_MAX];
     char urlPreSuffix[RTSP_PARAM_STRING_MAX];
     char urlSuffix[RTSP_PARAM_STRING_MAX];
+    char urlParams[RTSP_PARAM_STRING_MAX];
     char cseq[RTSP_PARAM_STRING_MAX];
     char sessionIdStr[RTSP_PARAM_STRING_MAX];
     unsigned contentLength = 0;
@@ -877,6 +879,7 @@
 						    cmdName, sizeof cmdName,
 						    urlPreSuffix, sizeof urlPreSuffix,
 						    urlSuffix, sizeof urlSuffix,
+                urlParams, sizeof urlParams,
 						    cseq, sizeof cseq,
 						    sessionIdStr, sizeof sessionIdStr,
 						    contentLength);
@@ -920,7 +923,7 @@
 	  handleCmd_notSupported();
 	}
       } else if (strcmp(cmdName, "DESCRIBE") == 0) {
-	handleCmd_DESCRIBE(urlPreSuffix, urlSuffix, (char const*)fRequestBuffer);
+	handleCmd_DESCRIBE(urlPreSuffix, urlSuffix, urlParams, (char const*)fRequestBuffer);
       } else if (strcmp(cmdName, "SETUP") == 0) {
 	Boolean areAuthenticated = True;
 
@@ -945,7 +948,7 @@
 	  }
 	}
 	if (clientSession != NULL) {
-	  clientSession->handleCmd_SETUP(this, urlPreSuffix, urlSuffix, (char const*)fRequestBuffer);
+	  clientSession->handleCmd_SETUP(this, urlPreSuffix, urlSuffix, urlParams, (char const*)fRequestBuffer);
 	  playAfterSetup = clientSession->fStreamAfterSETUP;
 	} else if (areAuthenticated) {
 	  handleCmd_sessionNotFound();
@@ -1007,7 +1010,7 @@
 	  if (strcmp(acceptStr, "application/x-rtsp-tunnelled") == 0) {
 	    isValidHTTPCmd = False;
 	  } else {
-	    handleHTTPCmd_StreamingGET(urlSuffix, (char const*)fRequestBuffer);
+	    handleHTTPCmd_StreamingGET(urlSuffix, urlParams, (char const*)fRequestBuffer);
 	  }
 	} else if (strcmp(cmdName, "GET") == 0) {
 	  handleHTTPCmd_TunnelingGET(sessionCookie);
@@ -1421,7 +1424,7 @@
 
 void RTSPServer::RTSPClientSession
 ::handleCmd_SETUP(RTSPServer::RTSPClientConnection* ourClientConnection,
-		  char const* urlPreSuffix, char const* urlSuffix, char const* fullRequestStr) {
+		  char const* urlPreSuffix, char const* urlSuffix, char const* urlParams, char const* fullRequestStr) {
   // Normally, "urlPreSuffix" should be the session (stream) name, and "urlSuffix" should be the subsession (track) name.
   // However (being "liberal in what we accept"), we also handle 'aggregate' SETUP requests (i.e., without a track name),
   // in the special case where we have only a single track.  I.e., in this case, we also handle:
@@ -1434,7 +1437,7 @@
   do {
     // First, make sure the specified stream name exists:
     ServerMediaSession* sms
-      = fOurServer.lookupServerMediaSession(streamName, fOurServerMediaSession == NULL);
+      = fOurServer.lookupServerMediaSession(streamName, urlParams, fOurServerMediaSession == NULL);
     if (sms == NULL) {
       // Check for the special case (noted above), before we give up:
       if (urlPreSuffix[0] == '\0') {
@@ -1447,7 +1450,7 @@
       trackId = NULL;
       
       // Check again:
-      sms = fOurServer.lookupServerMediaSession(streamName, fOurServerMediaSession == NULL);
+      sms = fOurServer.lookupServerMediaSession(streamName, urlParams, fOurServerMediaSession == NULL);
     }
     if (sms == NULL) {
       if (fOurServerMediaSession == NULL) {
@@ -2082,7 +2085,8 @@
 
 Boolean RTSPServerWithREGISTERProxying::weImplementREGISTER(char const* proxyURLSuffix, char*& responseStr) {
   // First, check whether we have already proxied a stream as "proxyURLSuffix":
-  if (proxyURLSuffix != NULL && lookupServerMediaSession(proxyURLSuffix) != NULL) {
+  // IHP: use blank urlParams for lookupMediaSession
+  if (proxyURLSuffix != NULL && lookupServerMediaSession(proxyURLSuffix, "") != NULL) {
     responseStr = strDup("451 Invalid parameter");
     return False;
   }
Index: liveMedia/RTSPServerSupportingHTTPStreaming.cpp
===================================================================
--- liveMedia/RTSPServerSupportingHTTPStreaming.cpp	(revision 14473)
+++ liveMedia/RTSPServerSupportingHTTPStreaming.cpp	(revision 14474)
@@ -77,7 +77,7 @@
 }
 
 void RTSPServerSupportingHTTPStreaming::RTSPClientConnectionSupportingHTTPStreaming
-::handleHTTPCmd_StreamingGET(char const* urlSuffix, char const* /*fullRequestStr*/) {
+::handleHTTPCmd_StreamingGET(char const* urlSuffix, char const* urlParams, char const* /*fullRequestStr*/) {
   // If "urlSuffix" ends with "?segment=<offset-in-seconds>,<duration-in-seconds>", then strip this off, and send the
   // specified segment.  Otherwise, construct and send a playlist that consists of segments from the specified file.
   do {
@@ -90,7 +90,7 @@
     streamName[questionMarkPos-urlSuffix] = '\0';
 
     do {
-      ServerMediaSession* session = fOurServer.lookupServerMediaSession(streamName);
+      ServerMediaSession* session = fOurServer.lookupServerMediaSession(streamName, urlParams);
       if (session == NULL) {
 	handleHTTPCmd_notFound();
 	break;
@@ -165,7 +165,7 @@
   // Construct and send a playlist that describes segments from the specified file.
 
   // First, make sure that the named file exists, and is streamable:
-  ServerMediaSession* session = fOurServer.lookupServerMediaSession(urlSuffix);
+  ServerMediaSession* session = fOurServer.lookupServerMediaSession(urlSuffix, urlParams);
   if (session == NULL) {
     handleHTTPCmd_notFound();
     return;
Index: liveMedia/StreamParser.hh
===================================================================
--- liveMedia/StreamParser.hh	(revision 14473)
+++ liveMedia/StreamParser.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _STREAM_PARSER_HH
 #define _STREAM_PARSER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FRAMED_SOURCE_HH
 #include "FramedSource.hh"
 #endif
 
-class StreamParser {
+class LIVEMEDIALIB_API StreamParser {
 public:
   virtual void flushInput();
 
